<script>
import axios from 'axios';
import { useFieldsDataStore } from '../stores/fields_data.store';
import { usePreviewStore } from '../stores/preview.store';
import { useLastSignatureStore } from '../stores/last_signature.store';

const baseUrl = `${import.meta.env.VITE_API_URL}`;

export default {
    data() {
        return {
            fieldsDataStore: useFieldsDataStore(),
            previewStore: usePreviewStore(),
            lastSigStore: useLastSignatureStore(),
            layout: ''
        };
    },
    methods: {
        // If user has stored signatures, show last created, otherwise show default
        async setDefaultLayout() {
            if (Object.keys(this.lastSigStore.signatureObject).length === 0) {
                await axios
                    .get(`${baseUrl}/layouts/1`)
                    .then((r) => (this.layout = r.data.html_structure));
            } else {
                const owner_id = this.lastSigStore.signatureObject.owner_id;
                const signature_id = this.lastSigStore.signatureObject.id;

                await axios
                    .get(`${baseUrl}/users/${owner_id}/layouts/${signature_id}`)
                    .then((r) => (this.layout = r.data.html));
            }
            this.previewStore.update(this.layout);
        },
        getLayout() {
            this.layout = this.previewStore.html;
        }
    },
    mounted() {
        this.setDefaultLayout();
    },
    watch: {
        // eslint-disable-next-line
        'previewStore.html'(newValue, oldValue) {
            this.getLayout();
        }
    }
};
</script>

<template>
    <el-card shadow="never" id="layout-card"><div v-html="layout"></div></el-card>
</template>

<style>
#layout-card {
    align-self: start;
    max-height: 400px;
}
</style>
